"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const grpc_1 = __importDefault(require("grpc"));
const dotenv_1 = __importDefault(require("dotenv"));
const node_multiprocess_1 = __importDefault(require("node-multiprocess"));
dotenv_1.default.config();
const worker_pb_1 = __importDefault(require("../gen/worker_pb"));
const worker_grpc_pb_1 = __importDefault(require("../gen/worker_grpc_pb"));
const DEFAULT_PORT = 50015;
const PORT = process.env.SERVER_PORT || DEFAULT_PORT;
const POOL_SIZE = 2;
node_multiprocess_1.default.setMaxProcesses(POOL_SIZE);
const pool = node_multiprocess_1.default.getInstance();
function looseJsonParse(obj) {
    return Function('"use strict";return (' + obj + ')')();
}
function addJob(call, callback) {
    return __awaiter(this, void 0, void 0, function* () {
        const fn = call.request.getFn();
        const args = call.request.getArgsList();
        const result = yield pool.addJob(looseJsonParse(fn), ...args);
        const reply = new worker_pb_1.default.AddJobReply();
        reply.setResult(result.toString());
        callback(null, reply);
    });
}
(() => {
    const server = new grpc_1.default.Server();
    server.addService(worker_grpc_pb_1.default.WorkerService, { addJob });
    server.bind(`0.0.0.0:${PORT}`, grpc_1.default.ServerCredentials.createInsecure());
    console.info(`Server running on ${PORT}`);
    server.start();
})();
//# sourceMappingURL=distributedServer.js.map